%define debug_package	%{nil}
%define	_release	1	
# major version of PLFS
%define pmajor	2
# minor version of PLFS
%define pminor	5
# patch version of PLFS
%define ppatch	0

%if %{ppatch}==0
%define pversion %{pmajor}.%{pminor}
%else
%define pversion %{pmajor}.%{pminor}.%{ppatch}
%endif

Name:		plfs-core
Summary:	plfs - Parallel Log Structured File System
Version:    %{pversion}
Release:	%{_release}%{?dist}
License:	LANS LLC
Group:		System Environment/Filesystems
Source:		%{name}-%{version}.tar.gz
URL:		http://institutes.lanl.gov/plfs
BuildRoot:	%{_tmppath}/plfs-%{version}-root
#if 0%{?suse_version}
#Requires:       fuse, libfuse2
#%else
#Requires:       fuse, fuse-libs
#%endif
Requires:       %{name}-libs
BuildRequires:  fuse-devel, pkgconfig
BuildRequires:	cmake zlib-devel

%description
Parallel Log Structured File System 
transparent filesystem middleware layer intended to speed up 
small N to 1 strided write patterns to a parallel file system.

%package	libs
Summary:	Library files for plfs.
Group:		System Environment/Filesystems

%description libs
Library files for plfs.

%package	devel
Summary:	Development files for plfs
Group:		System Environment/Filesystems
Requires:	%{name}-libs

%description devel
Development files for plfs

%prep
%setup -q

%build
cmake -DCMAKE_INSTALL_PREFIX:PATH=%{_prefix} \
      -DLIBDIR:PATH=%{_libdir} \
      -DBINDIR:PATH=%{_bindir} \
      -DSBINDIR:PATH=%{_sbindir} \
      -DINCLUDEDIR:PATH=%{_includedir} \
      -DMANDIR:PATH=%{_mandir} \
      -DADMIN_TOOLS=yes

%{__make}

%install
%{__mkdir_p} %{buildroot}{%{_sbindir},%{_bindir},%{_libdir}}
%{__mkdir_p} %{buildroot}%{_includedir}/plfs
# create the directories and files for init.d
%{__mkdir_p} %{buildroot}%{_initrddir}
%{__mkdir_p} %{buildroot}%{_sysconfdir}/sysconfig
#if 0%{?suse_version}
#   %{__install} -m 0755 contrib/init.d/plfs.init.suse %{buildroot}%{_initrddir}/plfs
#%else
#   %{__install} -m 0755 contrib/init.d/plfs.init %{buildroot}%{_initrddir}/plfs
#%endif
#%{__install} -m 0644 contrib/init.d/plfs.sysconfig %{buildroot}%{_sysconfdir}/sysconfig/plfs

%{__make} install DESTDIR=$RPM_BUILD_ROOT

cp -a src/COPYRIGHT.h .

%clean
if [ %{buildroot} != "/" ]; then
   %{__rm} -rf %{buildroot}
fi

%if 0
%post
if [ "$1" = "1" ]; then
   if [ -x /sbin/chkconfig ] ; then
       /sbin/chkconfig --add plfs
   fi
fi

%preun
if [ "$1" = "0" ]; then
    /sbin/service plfs stop
    if [ -x /sbin/chkconfig ] ; then
        /sbin/chkconfig --del plfs
    fi
fi
%endif

%files
%defattr(-,root,root,-)
%{_sbindir}/plfs
#config %{_initrddir}/plfs
#defattr(-,root,root,0644)
#config(noreplace) %{_sysconfdir}/sysconfig/plfs
%{_sbindir}/dcon
%{_sbindir}/findmesgbuf
%{_sbindir}/plfs_map
%{_sbindir}/plfs_query
%{_sbindir}/plfs_recover
%{_bindir}/plfs_check_config
%{_bindir}/plfs_flatten_index
%{_bindir}/plfs_ls
%{_bindir}/plfs_version
%{_mandir}/man1/plfs.1.gz
%{_mandir}/man1/dcon.1.gz
%{_mandir}/man1/findmesgbuf.1.gz
%{_mandir}/man1/plfs_check_config.1.gz
%{_mandir}/man1/plfs_flatten_index.1.gz
%{_mandir}/man1/plfs_map.1.gz
%{_mandir}/man1/plfs_recover.1.gz
%{_mandir}/man1/plfs_query.1.gz
%{_mandir}/man1/plfs_version.1.gz
%{_mandir}/man1/plfs_ls.1.gz
%{_mandir}/man5/plfsrc.5.gz

%files libs
%defattr(-,root,root,0755)
%doc src/COPYRIGHT.h
%{_libdir}/libplfs.so.*

%files devel
%defattr(-,root,root,0755)
%{_includedir}/plfs*
%{_libdir}/libplfs.a
%{_libdir}/libplfs.so
%{_mandir}/man3/is_plfs_path.3.gz
%{_mandir}/man3/plfs.3.gz
%{_mandir}/man3/plfs_access.3.gz
%{_mandir}/man3/plfs_chmod.3.gz
%{_mandir}/man3/plfs_chown.3.gz
%{_mandir}/man3/plfs_close.3.gz
%{_mandir}/man3/plfs_closedir_c.3.gz
%{_mandir}/man3/plfs_create.3.gz
%{_mandir}/man3/plfs_flatten_index.3.gz
%{_mandir}/man3/plfs_flush_writes.3.gz
%{_mandir}/man3/plfs_getattr.3.gz
%{_mandir}/man3/plfs_get_filetype.3.gz
%{_mandir}/man3/plfs_getxattr.3.gz
%{_mandir}/man3/plfs_invalidate_read_cache.3.gz
%{_mandir}/man3/plfs_link.3.gz
%{_mandir}/man3/plfs_mkdir.3.gz
%{_mandir}/man3/plfs_mode.3.gz
%{_mandir}/man3/plfs_open.3.gz
%{_mandir}/man3/plfs_opendir_c.3.gz
%{_mandir}/man3/plfs_query.3.gz
%{_mandir}/man3/plfs_read.3.gz
%{_mandir}/man3/plfs_readdir.3.gz
%{_mandir}/man3/plfs_readdir_c.3.gz
%{_mandir}/man3/plfs_readlink.3.gz
%{_mandir}/man3/plfs_rename.3.gz
%{_mandir}/man3/plfs_rmdir.3.gz
%{_mandir}/man3/plfs_statvfs.3.gz
%{_mandir}/man3/plfs_symlink.3.gz
%{_mandir}/man3/plfs_sync.3.gz
%{_mandir}/man3/plfs_trunc.3.gz
%{_mandir}/man3/plfs_unlink.3.gz
%{_mandir}/man3/plfs_utime.3.gz
%{_mandir}/man3/plfs_write.3.gz
%{_mandir}/man7/plfs.7.gz

%changelog
* Wed Oct 30 2013 David Shrader <dshrader@lanl.gov>
- Update to PLFS v2.5rc1
- Implement a process that can handle either a 2-member or 3-member version
  string without having to modify the spec file beyond the actual version
  numbers. That is, when changing PLFS versions, it is only necessary to
  update the actual version numbers and nothing else in the spec file.

* Wed Jul 17 2013 Zhang Jingwang <jingwang.zhang@emc.com>
- Remove the YAML library packaged with PLFS. It will be included in the
  PLFS library directly.

* Thu May 23 2013 David Shrader <dshrader@lanl.gov>
- use _mandir for directory to put man pages in instead of constructed path
  based on _prefix.
- Update to v2.4rc2.

* Wed May 22 2013 David Shrader <dshrader@lanl.gov>
- Update to v2.4rc1. A new build system is in use in 2.4. The YAML library is now
  packaged with PLFS.

* Mon Jul 2 2012 David Shrader <dshrader@lanl.gov>
- Added dcon, findmesgbuf, and mlogfacs.h.
- Moved all binaries except plfs into the plfs-lib rpm as they will be useful
  when using just the library. Also moved the respective man pages.
- Converted use of /etc to %{_sysconfdir} to help keep PLFS in line with
  distributions' standards of where to put system configuration files.

* Tue May 3 2011 Ben McClelland <ben@lanl.gov>
- suse has different dependencies than redhat put in distro specifics
- add plfs_recover, plfs_query, plfs_version and respective man pages

* Sat Jan 29 2011 Ben McClelland <ben@lanl.gov>
- Fixed the getattr bug 
- fixed ADIO parse conf error
- added global_summary_dir to the plfsrc
- fixed tools/plfs_flatten_index 

* Fri Jan 7 2011 Ben McClelland <ben@lanl.gov>
- Fixed a bug in rename.
- version 1.1.7

* Wed Jan 5 2011 Ben McClelland <ben@lanl.gov>
- Added support for a statfs override in the plfsrc file in response to ticket 35609.
- Bug fix for symbolic links.  I swear this is the second time I fixed this bug
- Bug fix in the multiple mount point parsing (unitialized string pointer)
- Added the multiple mount point parsing in plfsrc
- Index flattening in ADIO close for write
- Index broadcast in ADIO open for read

* Thu Jul 29 2010 Ben McClelland <ben@lanl.gov>
- switched to configure
- clean up some unnecessary .h files
- plfsrc is the new mapping/config file to try to hide backend from users more
- shared objects available
- VERSION and VERSION.LAYOUT added for compatibility checks

* Mon Jul 26 2010 Ben McClelland <ben@lanl.gov>
- combined lib and fuse spec
- version 0.1.6 currently in trunk

* Wed Apr 21 2010 Ben McClelland <ben@lanl.gov>
- version 0.5.1 changed from internal versioing: see detailed Changelog in svn
- split out fuse version and library spec

* Fri Aug 21 2009 Ben McClelland <ben@lanl.gov> 0.0.1.2-2
- "This version now supports links and it seems more stable" -John
- added Milo's patch to count skips
- Container extra_attempts

* Thu May 14 2009 Ben McClelland <ben@lanl.gov> 0.0.1.2-1
- new verion of plfs
- fixed version definition

* Wed Feb 11 2009 Ben McClelland <ben@lanl.gov> 0.0.1.0-1
- Initial package version
